package elements;

import elements.exceptions.ReadErrorChatException;
import elements.exceptions.SaveErrorChatException;

import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.stream.Collectors;

/**
 * Created by Guillermo Serrahima on 4/14/16.
 */
public class Persistence {
    private static Persistence persistence;

    private Persistence() {

    }

    public static Persistence getInstance() {
        if(persistence == null) persistence = new Persistence();
        return persistence;
    }


    public void saveChat(long chat_id, Chat c) throws SaveErrorChatException {
        try {
            ArrayList<List<String>> lists = c.saveLists();
            List<String> lines;

            for(int i = 0; i < lists.size(); i++) {
                lines = lists.get(i);
                String filename = lines.get(1).substring("#".length());

                if(lines.get(0).equals("#Chat name:")) {
                    filename = "chat_name";
                }
                Path file = Paths.get("geiserFiles/" + chat_id + "/lists/" + filename + ".txt");
                if (!Files.exists(file.getParent()))
                    Files.createDirectories(file.getParent());
                Files.write(file, lines, Charset.forName("UTF-8"));
            }
        } catch (IOException e) {
            throw new SaveErrorChatException(e);
        }

        return;
    }

    /*
    public HashMap<Long, Chat> readChats() throws ReadErrorChatException {
        HashMap<Long, Chat> chats = new HashMap<Long, Chat>();

        if(!Files.exists(Paths.get("chats/"))) return chats;

        try {
            String filename;
            Chat chat;
            List<Path> files = Files.walk(Paths.get("geiserFiles/"), 1).collect(Collectors.toList());
            Path file;
            List<String> lines;

            for(int i = 0; i < files.size(); i++) {
                file = files.get(i);
                filename = file.getFileName().toString();
                if(filename.endsWith(".txt")) {
                    filename = filename.substring(0,filename.length() - 4);
                    System.out.println("Reading " + filename);

                    lines = Files.readAllLines(file);
                    chats.put(Long.parseLong(filename), Chat.fromTxt(lines));
                }
            }
        } catch (IOException e) {
            e.printStackTrace();
            throw new ReadErrorChatException(e);
        }

        return chats;
    }
    */

}
